<?php
/*
 * Created on 19.12.2022 by Nico Schubert
 * Terminverwaltung Version 1.31 (https://www.php-space.info/terminverwaltungs-script/)
 * Copyright by Php-Space.info
 * Web: www.php-space.info
 * Support Forum: http://ww.php-space.info/forum/
 * E-Mail: info@schubertmedia.de
 */
if (headers_sent() == false) {
  if (!isset($_GET['PHPSESSID'])) $_GET['PHPSESSID'] = '';
  if ($_GET['PHPSESSID'] != '') {
    session_start($_GET['PHPSESSID']);
  } else {
    session_start();
  }
}
if (function_exists('date_default_timezone_set') === true) {
  $timezone = 'Europe/Berlin';
  date_default_timezone_set($timezone);
}
include_once('error_log.php');
include_once('inc/config.php');
include_once('function.php');
phpVersionCheck();
include_once('classes/dbcache_class.php');
$dbh = new DBI($datenbank_host, $datenbank_name, $datenbank_user, $datenbank_password, $cachedir);
if (!isset($_GET['monat'])) $_GET['monat'] = date('m');
if (!isset($_GET['jahr'])) $_GET['jahr'] = date('Y');
if (!isset($_GET['datum'])) $_GET['datum'] = date('Y-m-d');
if (!isset($_GET['eloade_cache'])) $_GET['reloade_cache'] = '';
if (!isset($_GET['logout'])) $_GET['logout'] = '';
if (!isset($_GET['delete'])) $_GET['delete'] = '';
if (!isset($_POST['senden'])) $_POST['senden'] = '';
if (!isset($_POST['username'])) $_POST['username'] = '';
if (!isset($_POST['userpassword'])) $_POST['userpassword'] = '';
$_GET['logout'] = sprintf('%d', $_GET['logout']);
$_GET['delete'] = sprintf('%d', $_GET['delete']);
$_GET['reloade_cache'] = sprintf('%d', $_GET['reloade_cache']);
$_GET['jamonathr'] = sprintf('%d', $_GET['monat']);
$_GET['jahr'] = sprintf('%d', $_GET['jahr']);
$userinfo = array();
$userinfo['userpassword'] = '';
$userinfo['id'] = '';
$userinfo['name'] = '';
if (!checkdate($_GET['monat'], 1, $_GET['jahr'])) {
  $aktuellermonat_array = getdate();
  $_GET['monat'] = $aktuellermonat_array['mon'];
  $_GET['jahr'] = $aktuellermonat_array['year'];
}
if ($_POST['senden'] == 1 and $_POST['username'] != '' and $_POST['userpassword'] != '') {
  $_POST['username'] = preg_replace("/\+/i", "", $_POST['username']);
  $sql = sprintf("SELECT * FROM `%suser` WHERE name='%s' LIMIT 1", $datenbank_praefix, $dbh->DBD->escape($_POST['username']));
  $sth = $dbh->prepare($sql, '-1');
  $sth->execute();
  $userinfo = $sth->fetchrow_array();
  $sth->finish();
}
if ($_GET['logout'] == '1') {
  $_SESSION = array();
  if (isset($_COOKIE[session_name()])) {
    setcookie(session_name(), '', time() - 42000, '/');
  }
  session_destroy();
  header('location:index.php');
  exit;
}
if ($userinfo['userpassword'] == md5($_POST['userpassword'])) {
  $_SESSION['sessionid'] = session_id();
  $_SESSION['user_id'] = $userinfo['id'];
  $_SESSION['user_name'] = $userinfo['name'];
}
if (empty($_SESSION['sessionid']) or $_SESSION['user_id'] == '' or $_SESSION['user_name'] == '') {
  $ausgabe = '<html>';
  $ausgabe .= '<head>';
  $ausgabe .= '<title>Terminverwaltung</title>';
  $ausgabe .= '<link rel="stylesheet" type="text/css" href="style.css">';
  $ausgabe .= '</head>';
  $ausgabe .= '<body>';
  $ausgabe .= '<form method="post" action="index.php">';
  $ausgabe .= '<input type="hidden" name="senden" value="1">';
  $ausgabe .= '<table style="border: #000000 1px solid; margin:0;padding:0;width:490px">';
  $ausgabe .= ' <tr>';
  $ausgabe .= '  <td colspan="2" style="background-color:#ccc;padding:5px;"><b>Login</b></td>';
  $ausgabe .= ' </tr>';
  $ausgabe .= ' <tr>';
  $ausgabe .= '  <td colspan="2" style="padding:5px;">Bitte loggen Sie sich ein.</td>';
  $ausgabe .= ' </tr>';
  $ausgabe .= ' <tr>';
  $ausgabe .= '  <td style="padding:5px;">Username</td>';
  $ausgabe .= '  <td style="padding:5px;"><input type="text" name="username" size="25"></td>';
  $ausgabe .= ' </tr>';
  $ausgabe .= ' <tr>';
  $ausgabe .= '  <td style="padding:5px;">Passwort</td>';
  $ausgabe .= '  <td style="padding:5px;"><input type="password" name="userpassword" size="25"></td>';
  $ausgabe .= ' </tr>';
  $ausgabe .= ' <tr>';
  $ausgabe .= '</table><p></p>';
  $ausgabe .= '<input type="submit" value="Login">';
  $ausgabe .= '</form>';
  $ausgabe .= '</body>';
  $ausgabe .= '</html>';
  eval(base64_decode("JGF1c2dhYmUgLj0nPHA+Q29weXJpZ2h0IGJ5IDxhIGhyZWY9Imh0dHBzOi8vd3d3LnBocC1zcGFjZS5pbmZvLyIgdGFyZ2V0PSJfYmxhbmsiPlBocC1TcGFjZS5pbmZvPC9hPjwvcD4nOwplY2hvICRhdXNnYWJlOw=="));
  exit;
}
session_id($_SESSION['sessionid']);
if ($_GET['delete'] != '') {
  $sql_delete = sprintf('DELETE FROM `%stermin` WHERE `id` = \'%d\' LIMIT 1;', $datenbank_praefix, $_GET['delete']);
  $sth = $dbh->prepare($sql_delete);
  $sth->execute();
  $sql_delete = sprintf('DELETE FROM `%stermin_emails` WHERE `termin_id` = \'%d\';', $datenbank_praefix, $_GET['delete']);
  $sth = $dbh->prepare($sql_delete);
  $sth->execute();
  $_GET['reloade_cache'] = 1;
}
$start_timestamp = mktime(10, 10, 0, $_GET['monat'], 1, $_GET['jahr']);
$gewaehltermonat_array = getdate($start_timestamp);
$days = array('Montag', 'Dienstag', 'Mittwoch', 'Donnerstag', 'Freitag', 'Samstag', 'Sonntag');
$monate = array('Januar', 'Februar', 'März', 'April', 'Mai', 'Juni', 'Juli', 'August', 'September', 'Oktober', 'November', 'Dezember');
$ausgabe = '';
$ausgabe .= '<html>';
$ausgabe .= '<head>';
$ausgabe .= '<title>Terminverwaltung</title>';
$ausgabe .= '<link rel="stylesheet" type="text/css" href="style.css">';
$ausgabe .= '</head>';
$ausgabe .= '<body>';
include_once('navigation.php');
$ausgabe .= '<form action="index.php" method="get">';
$ausgabe .= '<select name="monat">';
for ($x = 1; $x <= count($monate); $x++) {
  $ausgabe .= sprintf('<option value="%d" %s>%s</option>', $x, ($x == $_GET['monat']) ? ' SELECTED' : '', $monate[($x - 1)]);
}
$ausgabe .= '</select>';
$ausgabe .= '<select name="jahr">';
for ($x = ($_GET['jahr'] - 25); $x < ($_GET['jahr'] + 25); $x++) {
  $ausgabe .= sprintf('<option %s>%d</option>', ($x == $_GET['jahr']) ? ' SELECTED' : '', $x);
}
$ausgabe .= '</select>';
$ausgabe .= '<input type="submit" value="Los geht\'s!">';
$ausgabe .= '</form><p>';

$gewaehltermonat_start = ($gewaehltermonat_array['wday'] - 1);
if ($gewaehltermonat_start < 0) {
  $gewaehltermonat_start = 6;
}
$ausgabe .= '<TABLE style="border: #000000 1px solid; margin:0; padding:5px;width:490px" cellpadding="0" cellspacing="0">';
foreach ($days as $day)
  $ausgabe .= sprintf('<td style="background-color:#ccc;"><b>%s</b></td>', $day);
for ($zaehler = 0; $zaehler < (6 * 7); $zaehler++) {
  $tagArr = getdate($start_timestamp);
  if ((($zaehler) % 7) == 0) {
    if ($tagArr['mon'] != $_GET['monat'])
      break;
    $ausgabe .= '</tr><tr>';
  }
  if ($zaehler < $gewaehltermonat_start) {
    $vormonat_array = getdate(mktime(0, 0, 0, $_GET['monat'], 1, $_GET['jahr']) - (($gewaehltermonat_start - $zaehler) * 60 * 60 * 24));

    $ausgabe .= sprintf('<td><a href="index.php?%s&datum=%s-%s-%s">%s</a></td>', SID, $vormonat_array['year'], $vormonat_array['mon'], $vormonat_array['mday'], $vormonat_array['mday']);
  } elseif ($tagArr['mon'] != $_GET['monat']) {

    $sql_select = sprintf('SELECT * FROM `%stermin` WHERE `datum` LIKE  \'%s-%s-%s%%\';', $datenbank_praefix, $tagArr['year'], sprintf("%02d", $tagArr['mon']), sprintf("%02d", $tagArr['mday']));
    $sth = $dbh->prepare($sql_select, (($_GET['reloade_cache'] == 1) ? '-1' : '60'));
    $sth->execute();
    $farbe = '#FFF';
    if ($sth->rows() != 0) {
      $farbe = '#FBB117';
    }
    $sth->finish();
    if ($tagArr['mday'] == date('d') and date('m') == $_GET['monat'] and $_GET['jahr'] == date('Y')) {
      $farbe = '#FF0000';
    }
    $ausgabe .= sprintf('<td style="background-color:%s;"><a href="index.php?%s&datum=%s-%s-%s">%s</a></td>', $farbe, SID, $tagArr['year'], $tagArr['mon'], $tagArr['mday'], $tagArr['mday']);
    $start_timestamp += (60 * 60 * 24);
  } else {

    $sql_select = sprintf('SELECT * FROM `%stermin` WHERE `datum` LIKE  \'%s-%s-%s%%\';', $datenbank_praefix, $tagArr['year'], sprintf("%02d", $tagArr['mon']), sprintf("%02d", $tagArr['mday']));
    $sth = $dbh->prepare($sql_select, (($_GET['reloade_cache'] == 1) ? '-1' : '60'));
    $sth->execute();
    $farbe = '#FFF';
    if ($sth->rows() != 0) {
      $farbe = '#FBB117';
    }
    $sth->finish();
    if ($tagArr['mday'] == date('d') and date('m') == $_GET['monat'] and $_GET['jahr'] == date('Y')) {
      $farbe = '#FF0000';
    }

    $ausgabe .= sprintf('<td style="background-color:%s;"><a href="index.php?%s&datum=%s-%s-%s">%s</a></td>', $farbe, SID, $tagArr['year'], $tagArr['mon'], $tagArr['mday'], $tagArr['mday']);
    $start_timestamp += (60 * 60 * 24);
  }
}
$ausgabe .= '</tr></table>';
$ausgabe .= sprintf('<a href="index.php?%s&monat=%d&jahr=%d"><</a> ', SID, (($_GET['monat'] - 1) != 0) ? ($_GET['monat'] - 1) : '12', (($_GET['monat'] - 1) != 0) ? $_GET['jahr'] : ($_GET['jahr'] - 1));
$ausgabe .= sprintf('<a href="index.php?%s&monat=%d&jahr=%d">></a>', SID, (($_GET['monat'] + 1) < 13) ? ($_GET['monat'] + 1) : '1', (($_GET['monat'] + 1) < 13) ? $_GET['jahr'] : ($_GET['jahr'] + 1));
if (check_date_mysql($_GET['datum']) == true) {
  $sql_select = sprintf('SELECT * FROM `%stermin` WHERE `datum` LIKE  \'%s%%\';', $datenbank_praefix, date_mysql2format($_GET['datum']));
  $sth = $dbh->prepare($sql_select, (($_GET['reloade_cache'] == 1) ? '-1' : '60'));
  $sth->execute();
  $ausgabe .= sprintf("<p><b>Termine vom %s</b></p>", date_mysql2german($_GET['datum']));
  $ausgabe .= sprintf("<p>Hier können Sie ein <a href=\"termin_eintragen.php?%s&datum=%s\">Termin eintragen</a> für den %s.</p><hr style=\"border: #000000 1px solid; width:490px\" align=\"left\">", SID, $_GET['datum'], date_mysql2german($_GET['datum']));
  if ($sth->rows() == 0) {
    $ausgabe .= '<p>Es sind noch keine Termine eingetragen.</p>';
  } else {
    while ($daten = $sth->fetchrow_hash()) {
      $ausgabe .= sprintf("<p><b>%s</b><br><i>Termin eingetragen von %s ist um %s</i> (<a href=\"index.php?%s&delete=%s&datum=%s\">löschen</a>)<br>%s</p>", stripslashes($daten['titel']), userid_to_nameemail_link($daten['user_id']), date_His_mysql2german($daten['datum']), SID, $daten['id'], $_GET['datum'], stripslashes(str_replace("\n", "<br>", $daten['nachricht'])));
    }
  }
  $sth->finish();
}
$ausgabe .= '<p style="border: #000000 1px solid; margin:0; padding:5px;width:490px">';
$ausgabe .= '  <span style="background-color:#FFF; text-align: center;">&nbsp;&nbsp;&nbsp;&nbsp;</span> <i>Erklärung</i><br>';
$ausgabe .= '  <span style="background-color:#FF0000; text-align: center;">&nbsp;&nbsp;&nbsp;&nbsp;</span> Heute<br>';
$ausgabe .= '  <span style="background-color:#FBB117; text-align: center;">&nbsp;&nbsp;&nbsp;&nbsp;</span> Termine vorhanden<br>';
$ausgabe .= '</p>';
$ausgabe .= "</body>\n";
$ausgabe .= "</html>\n";
eval(base64_decode("JGF1c2dhYmUgLj0nPHA+Q29weXJpZ2h0IGJ5IDxhIGhyZWY9Imh0dHBzOi8vd3d3LnBocC1zcGFjZS5pbmZvLyIgdGFyZ2V0PSJfYmxhbmsiPlBocC1TcGFjZS5pbmZvPC9hPjwvcD4nOwplY2hvICRhdXNnYWJlOw=="));