<?php
/*
 * Created on 19.12.2022 by Nico Schubert
 * Terminverwaltung Version 1.31 (https://www.php-space.info/terminverwaltungs-script/)
 * Copyright by Php-Space.info
 * Web: www.php-space.info
 * Support Forum: http://ww.php-space.info/forum/
 * E-Mail: info@schubertmedia.de
 */
if (headers_sent() == false) {
  if (!isset($_GET['PHPSESSID'])) $_GET['PHPSESSID'] = '';
  if ($_GET['PHPSESSID'] != '') {
    session_start($_GET['PHPSESSID']);
  } else {
    session_start();
  }
  if (empty($_SESSION["sessionid"])) {
    header("location:index.php");
    exit;
  }
}
//---------------------
include_once('error_log.php');
include_once('inc/config.php');
include_once('function.php');
phpVersionCheck();
include_once('classes/dbcache_class.php');
//---------------------
$dbh = new DBI($datenbank_host, $datenbank_name, $datenbank_user, $datenbank_password, $cachedir);
//---------------------
$ausgabe_erfolgreich = '';
$ausgabe_fehler = '';
if (!isset($_POST['id'])) $_POST['id'] = '0'; else $_POST['id'] = sprintf("%d", $_POST['id']);
if (!isset($_GET['id'])) $_GET['id'] = $_POST['id']; else $_GET['id'] = sprintf("%d", $_GET['id']);
if (!isset($_GET['del'])) $_GET['del'] = '0'; else $_GET['del'] = sprintf("%d", $_GET['del']);
if (!isset($_POST['senden'])) $_POST['senden'] = '0'; else $_POST['senden'] = sprintf("%d", $_POST['senden']);
if (!isset($_POST['betreff'])) $_POST['betreff'] = '';
if (!isset($_POST['text'])) $_POST['text'] = '';
if (!isset($_POST['new_record'])) $_POST['new_record'] = '0'; else $_POST['new_record'] = sprintf("%d", $_POST['new_record']);
$_GET['reloade_cache'] = sprintf('%d', $_GET['reloade_cache']);
/**
 * Löschen
 */
if($_GET['del']==='1' && $_GET['id'] !== '0'){
  $sql_delete = sprintf('DELETE FROM `%stpl_emails` WHERE `id` = \'%d\' AND `user_id` = \'%d\' LIMIT 1;', $datenbank_praefix, $_GET['id'], $_SESSION["user_id"]);
  $sth = $dbh->prepare($sql_delete);
  $sth->execute();
  if (headers_sent() == false) {
    header("location:email_tpl_aendern.php" . SID);
  }
  exit;
}
if ($_POST['new_record'] == '1') {
  $id_uebergabe = $_GET['id'];
  $_GET['id'] = '0';
}
if ($_GET['del']!== '1' && $_POST['senden'] === '1' && $_POST['betreff'] != '' && $_POST['text'] != '' && $_GET['id'] === '0' && $_SESSION["user_id"] != '') {
  /**
   * Neu anlegen
   */
  $sql_insert = sprintf('INSERT INTO `%stpl_emails` (`betreff`,`text`,`user_id`) VALUES(\'%s\', \'%s\' , \'%d\');', $datenbank_praefix, $dbh->DBD->escape($_POST['betreff']), $dbh->DBD->escape($_POST['text']), $dbh->DBD->escape($_SESSION["user_id"]));
  $sth = $dbh->prepare($sql_insert);
  $sth->execute();
  $_GET['reloade_cache'] = 1;
  $ausgabe_erfolgreich = 'Der Eintrag wurde gespeichert!';
} else if ($_GET['del']!== '1' && $_POST['senden'] === '1' && $_POST['betreff'] != '' && $_POST['text'] != '' && $_GET['id'] !== '0' && $_SESSION["user_id"] != '') {
  /**
   * Update
   */
  $sql_update = sprintf('UPDATE `%stpl_emails` SET `betreff` = \'%s\', `text` = \'%s\' WHERE `id` = \'%s\' AND `user_id` = \'%s\' LIMIT 1;', $datenbank_praefix, $dbh->DBD->escape($_POST['betreff']), $dbh->DBD->escape($_POST['text']), $dbh->DBD->escape($_GET['id']), $dbh->DBD->escape($_SESSION["user_id"]));
  $sth = $dbh->prepare($sql_update);
  $sth->execute();
  $_GET['reloade_cache'] = 1;
  $ausgabe_erfolgreich = 'Der Eintrag wurde geändert!';
}

if ($_GET['id'] !== '0' &&  $_SESSION["user_id"] !== '0') {
  /**
   * Auslesen
   */
  var_dump($_GET['reloade_cache']);
  $sql_select = sprintf('SELECT * FROM `%stpl_emails` WHERE `id` = \'%s\' AND `user_id` = \'%s\' LIMIT 1;', $datenbank_praefix, $dbh->DBD->escape($_GET['id']), $_SESSION["user_id"]);
  $sth = $dbh->prepare($sql_select,  (($_GET['reloade_cache'] == 1) ? '-1' : '60'));
  $sth->execute();
  $daten = $sth->fetchrow_hash();
  var_dump($daten);
  if (isset($daten['betreff'])) $_POST['betreff'] = $daten['betreff'];
  if (isset($daten['text'])) $_POST['text'] = $daten['text'];
  $sth->finish();
}
if ($_POST['new_record'] === '1') {
  $_GET['id'] = $id_uebergabe;
}
$ausgabe = '';
$ausgabe .= '<html>';
$ausgabe .= '<head>';
$ausgabe .= '<title>Terminverwaltung</title>';
$ausgabe .= '<link rel="stylesheet" type="text/css" href="style.css">';
$ausgabe .= '</head>';
$ausgabe .= '<body>';
include_once('navigation.php');

if ($ausgabe_erfolgreich != '') $ausgabe .= sprintf('<p><span style="color: green; ">%s</span></p>', $ausgabe_erfolgreich);
if ($ausgabe_fehler != '') $ausgabe .= sprintf('<p><span style="color: red; ">%s</span></p>', $ausgabe_fehler);

/**
 * Ausgabe der angelegte TPL`s
 */
$ausgabe .= '<div id="einstellung_tab">';
$ausgabe .= '  	<div id="w100">';
$ausgabe .= '		<div style="background-color:#ccc; padding:5px"><b>Angelegte E-Mail-Vorlagen</b></div>';

$sql_select = sprintf('SELECT id, betreff FROM `%stpl_emails` WHERE `user_id` = \'%s\';', $datenbank_praefix, $_SESSION["user_id"]);
$sth = $dbh->prepare($sql_select,  (($_GET['reloade_cache'] == '1') ? '-1' : '60'));
$sth->execute();
if ($sth->rows() == '0') {
  $ausgabe .= '<div style="float:none;padding:5px">Es sind noch keine E-Mail-Vorlagen angelegt</div>';
} else {
  while ($daten = $sth->fetchrow_hash()) {
    $ausgabe .= sprintf('		<div style="float:none;padding:5px">- %s (<a href="email_tpl_aendern.php?%s&id=%d">bearbeiten</a>, <a href="email_tpl_aendern.php?%s&id=%d&del=1">löschen</a>)</div>
', $daten['betreff'], SID, $daten['id'],SID, $daten['id']);
  }
}
$sth->finish();

$ausgabe .= '    </div>';
$ausgabe .= '</div><br>';
$ausgabe .= '<form action="email_tpl_aendern.php?' . SID . '" method="post">';
$ausgabe .= '<input type="hidden" name="senden" value="1">';
if ($_GET['id'] != 0) $ausgabe .= sprintf('<input type="hidden" name="id" id="id_uebergabe" value="%d">', $_GET['id']);
$ausgabe .= '<div id="einstellung_tab">';
$ausgabe .= '  	<div id="w100">';
$ausgabe .= '		<div style="background-color:#ccc; padding:5px"><b>E-Mail-Vorlagen ändern/anlegen</b></div>';
$ausgabe .= '		<div style="float:none;padding:5px"><b>Betreff für die E-Mail</b></div>';
$ausgabe .= sprintf('		<div style="float:none;padding:5px"><input type="text" name="betreff" size="35" style="width:98%%" value="%s"></div>
', stripslashes($_POST['betreff']));
$ausgabe .= '		<div style="float:none;padding:5px"><b>E-Mail Text</b><p>Platzhalter die verwendet werden können im E-Mail Text:<br><br><i>%ueberschrift%</i> = Überschrift des Termin<br><i>%text%</i> = Text des Termin</p></div>';
$ausgabe .= sprintf('		<div style="float:none;padding:5px"><textarea name="text" style="width:98%%" rows="5">%s</textarea></div>
', stripslashes($_POST['text']));
if ($_GET['id'] != 0) {
  $ausgabe .= '		<div style="float:left; text-align:justify; width:5%;padding:5px"><input type="checkbox" name="new_record" value="1" id="new_record"></div>';
  $ausgabe .= '		<div style="float:none;padding:5px">als neuen Datensatz speichern</div>';
}
$ausgabe .= '    </div>';
$ausgabe .= '</div>';
$ausgabe .= '<p></p>';
$ausgabe .= '<input type="submit" value="Speichern">';
$ausgabe .= '</form>';
$ausgabe .= '</body>';
$ausgabe .= '</html>';
eval(base64_decode("JGF1c2dhYmUgLj0nPHA+Q29weXJpZ2h0IGJ5IDxhIGhyZWY9Imh0dHBzOi8vd3d3LnBocC1zcGFjZS5pbmZvLyIgdGFyZ2V0PSJfYmxhbmsiPlBocC1TcGFjZS5pbmZvPC9hPjwvcD4nOwplY2hvICRhdXNnYWJlOw=="));